#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	lxc
Version		:	6.0.1
Release		:	17.2.0.rel%{?dist}
Summary		:	Linux Resource Containers
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2+ and GPLv2
URL		:	https://linuxcontainers.org/lxc
			# https://github.com/lxc/lxc
			# git archive --format tar --prefix=lxc-lxc-5.0.1.b16e4ea/ HEAD | gzip > ../lxc-5.0.1.b16e4ea.tar.gz

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	automake
BuildRequires	:	bash-completion
BuildRequires	:	dbus-devel
BuildRequires	:	docbook2X
BuildRequires	:	doxygen
BuildRequires	:	libtool
BuildRequires	:	libcap-devel
BuildRequires	:	libseccomp-devel
BuildRequires	:	linux-headers
BuildRequires	:	make
BuildRequires	:	openssl-devel

Requires	:	%{name}-libs		= %{version}-%{release}
Requires	:	%{name}-templates	= %{version}-%{release}
#-----------------------------------------------------------------------------
%description
Linux Resource Containers provide process and resource isolation
without the overhead of full virtualization.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%{_bindir}/%{name}-*
%exclude %{_bindir}/%{name}-autostart
%{_datadir}/bash-completion/completions/_%{name}
%{_datadir}/bash-completion/completions/%{name}-*
%{_datadir}/%{name}/%{name}.functions
%{_mandir}/man1/%{name}*.1.gz
%{_mandir}/*/man1/%{name}*.1.gz
%dir %attr(0755,root,root) %ghost /%{name}
%exclude %{_mandir}/man1/%{name}-autostart.1.gz
%exclude %{_mandir}/*/man1/%{name}-autostart.1.gz
%exclude %{_mandir}/man1/%{name}-user-nic.1.gz
%exclude %{_mandir}/*/man1/%{name}-user-nic.1.gz

#-----------------------------------------------------------------------------
%preun 
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sysconfdir}/rc.d/init.d/%{name}-net stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}-net
  %{_sbindir}/chkconfig --del %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post
if [ "$1" = 1 ]; then
  mkdir -p /%{name}
  cat >> /etc/fstab << "EOF"
#-----------------------------------------------------------------------------
#mounting cgroup
none			/%{name}		cgroup2	defaults	0 0
#-----------------------------------------------------------------------------
EOF
  fi
%{_sbindir}/chkconfig --add %{name}
%{_sbindir}/chkconfig --add %{name}-net

#=============================================================================
%package		libs

Summary		:	Runtime library files for %{name}

#--------------------------------------------------------------------
%description		libs
Linux Resource Containers provide process and resource
isolation without the overhead of full virtualization.
 
The %{name}-libs package contains libraries for
running %{name} applications.

#--------------------------------------------------------------------
%files			libs
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}/default.conf
%config(noreplace) %{_sysconfdir}/sysconfig/ifconfig.%{name}br0
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(0750,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%attr(0750,root,root) %{_sysconfdir}/rc.d/init.d/%{name}-net
%{_sbindir}/init.%{name}
%{_libdir}/%{name}/rootfs/README
%{_bindir}/%{name}-autostart
%{_libdir}/lib%{name}.so.*
%{_libexecdir}/%{name}/hooks/unmount-namespace
%{_libexecdir}/%{name}/%{name}-*
%{_datadir}/%{name}/hooks/*
%{_datadir}/%{name}/%{name}-patch.py*
%{_mandir}/man1/%{name}-autostart.1.gz
%{_mandir}/*/man1/%{name}-autostart.1.gz
%{_mandir}/man1/%{name}-user-nic.1.gz
%{_mandir}/*/man1/%{name}-user-nic.1.gz
%{_mandir}/man5/%{name}*.5.gz
%{_mandir}/*/man5/%{name}*.5.gz
%{_mandir}/man7/%{name}.7.gz
%{_mandir}/*/man7/%{name}.7.gz

#--------------------------------------------------------------------
%postun			libs
/usr/sbin/ldconfig

%post			libs
/usr/sbin/ldconfig

#=============================================================================
%package		templates

Summary		:	Templates for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs		= %{version}-%{release}
Requires	:	wget
Requires	:	xz

#-----------------------------------------------------------------------------
%description		templates
Linux Resource Containers provide process and resource
isolation without the overhead of full virtualization.
 
The %{name}-templates package contains templates for creating containers.
#-----------------------------------------------------------------------------
%files			templates
%defattr(-,root,root,-)
%config(noreplace) %{_datadir}/%{name}/config/common.conf
%{_datadir}/%{name}/config/common.conf.d/README
%{_datadir}/%{name}/config/common.seccomp
%{_datadir}/%{name}/config/nesting.conf
%{_datadir}/%{name}/config/oci.common.conf
%{_datadir}/%{name}/config/userns.conf
%{_datadir}/%{name}/templates/%{name}-*

#=============================================================================
%package		devel
Summary		:	Development files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Linux Resource Containers provide process and resource
isolation without the overhead of full virtualization.
 
The %{name}-devel package contains libraries and
header files for developing applications that use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/%{name}/*.h
%{_libdir}/lib%{name}.so

#=============================================================================
%package		doc
Summary		:	Documentation for %{name}

#-----------------------------------------------------------------------------
BuildArch	:	noarch

#-----------------------------------------------------------------------------
%description		doc
This package contains documentation for %{name}.

#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root,-)
%license COPYING
%{_defaultdocdir}/%{name}-%{version}/examples/*.conf

#=============================================================================
%prep
%setup -q 

tar xf %{SOURCE1}

cat							\
	%{name}-ok_addon/lxc-default			\
	>> config/etc/default.conf.lxcbr

#-----------------------------------------------------------------------------
#building application
%build

meson	setup						\
        --prefix=%{_prefix}				\
	--libdir=%{_libdir}				\
	--buildtype=plain				\
	-D init-script=sysvinit				\
	-D doc-path=%{_defaultdocdir}/%{name}-%{version}\
	-D systemd-unitdir=no				\
	_bld

meson	compile						\
	-C _bld

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
meson	install						\
	-C _bld					

#removing lxc own init script
%{__rm} -fr						\
	%{buildroot}%{_sysconfdir}/init.d

%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

%{__cp} -a						\
	%{name}-ok_addon/%{name}			\
	%{name}-ok_addon/%{name}-net			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/

%{__cp} -a						\
	%{name}-ok_addon/ifconfig.%{name}br0		\
	%{buildroot}%{_sysconfdir}/sysconfig

#preparing the cgroup directory
%{__mkdir}						\
	%{buildroot}/%{name}


#To remove libtool library and static library
find 								\
	%{buildroot}%{_libdir}					\
	\(							\
		 -name \*.la					\
		 -o						\
		 -name \*.a					\
	 \)							\
	-delete

#-----------------------------------------------------------------------------
%changelog
